# Class SelectBuilder

java.lang.Object
org.apache.cayenne.access.sqlbuilder.BaseBuilder
org.apache.cayenne.access.sqlbuilder.SelectBuilder

All Implemented Interfaces:
  `NodeBuilder`

public class SelectBuilder extends BaseBuilder

Since:
  4.2

- ## Field Summary

  ### Fields inherited from class BaseBuilder

  `nodes, root`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SelectBuilder`
  `distinct()`
  `SelectBuilder`
  `from(NodeBuilder table)`
  `SelectBuilder`
  `from(NodeBuilder... tables)`
  `SelectBuilder`
  `groupBy(NodeBuilder... params)`
  `SelectBuilder`
  `groupBy(Node node)`
  `SelectBuilder`
  `having(NodeBuilder... params)`
  `SelectBuilder`
  `having(Node node)`
  `SelectBuilder`
  `limitOffset(int limit, int offset)`
  `SelectBuilder`
  `orderBy(NodeBuilder param)`
  `SelectBuilder`
  `orderBy(NodeBuilder... params)`
  `SelectBuilder`
  `result(NodeBuilder selectExpression)`
  `SelectBuilder`
  `top(int count)`
  `SelectBuilder`
  `where(NodeBuilder... params)`
  `SelectBuilder`
  `where(Node node)`

  ### Methods inherited from class BaseBuilder

  `build, getRoot, node`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### distinct

    public SelectBuilder distinct()

  - ### top

    public SelectBuilder top(int count)

  - ### result

    public SelectBuilder result(NodeBuilder selectExpression)

  - ### from

    public SelectBuilder from(NodeBuilder table)

  - ### from

    public SelectBuilder from(NodeBuilder... tables)

  - ### where

    public SelectBuilder where(NodeBuilder... params)

  - ### where

    public SelectBuilder where(Node node)

  - ### orderBy

    public SelectBuilder orderBy(NodeBuilder... params)

  - ### orderBy

    public SelectBuilder orderBy(NodeBuilder param)

  - ### groupBy

    public SelectBuilder groupBy(NodeBuilder... params)

  - ### groupBy

    public SelectBuilder groupBy(Node node)

  - ### having

    public SelectBuilder having(NodeBuilder... params)

  - ### having

    public SelectBuilder having(Node node)

  - ### limitOffset

    public SelectBuilder limitOffset(int limit, int offset)